﻿using Infragistics.Documents.RichText;
using System;
using System.Collections.Generic;
using System.Windows;
using System.Windows.Data;

namespace RichSpellChecking
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        List<TextNode> nodes = new List<TextNode>();

        public MainWindow()
        {
            InitializeComponent();

            RichTextDocument doc = new RichTextDocument();
            doc.LoadFromPlainText(Environment.CurrentDirectory + "\\Text.txt");

            xamRichText.Document = doc;
        }

        private void btnSpellByTextNode_Click(object sender, RoutedEventArgs e)
        {
            nodes.Clear();

            foreach (var item in xamRichText.Document.RootNode.ChildNodes[0].ChildNodes)
            {
                if (item.HasChildNodes)
                {
                    foreach (var runNode in item.ChildNodes)
                    {
                        if (runNode.HasChildNodes)
                        {
                            foreach (TextNode textNode in runNode.ChildNodes)
                            {
                                nodes.Add(textNode);
                            }

                        }
                    }
                }
            }
            AddBindingsToSpell();
        }

        private void AddBindingsToSpell()
        {
            xamSpellChecker.SpellCheckTargets.Clear();
            foreach (TextNode node in nodes)
            {
                Binding bind = new Binding();
                bind.Source = node;
                bind.Mode = BindingMode.TwoWay;
                bind.Path = new PropertyPath("Text");

                xamSpellChecker.SpellCheckTargets.Add(bind);
            }

            xamSpellChecker.SpellCheck();
        }
    }
}